/*
  Project    : Fuzzy string comparision.   .
  Date       : 21.12.1996
  Author     : Kiva Vladimir <vlak@glasnet.ru>, http://www.glasnet.ru/~vlak
  Phile name : similar.c
  Description:
  Notes      : Comments are in Russian (CP1251).
       , ,   ,
    licence.txt,     .
  Modified   By    Reason
  04.07.1998 vlak     ,    
                    Unicode.
*/

// NB:   UNICODE- ,     
//  ;  ,   , 
//  .
//#define _UNICODE

#include "tchar.h"    // TCHAR, _TEXT
#include <stddef.h>   // NULL

/*
  CompResult     
         processStrings.
*/
typedef struct
{
 int iVariantsQty; //   .
 int iMatchesQty;  //  .
} CompResult;

/*
     processStrings      iSubLen+1 
 ,    pcA  pcB,     
     pcB   pcA.
    : pcA  pcB      ,
 iSubLen    0        
 .
*/
CompResult processStrings (TCHAR* pcA, TCHAR* pcB, int iSubLen)
{
 CompResult result;
 result.iVariantsQty = 0;
 result.iMatchesQty  = 0;

 while (pcB[iSubLen])
 {  //    B  iSubLen+1.
    TCHAR* pcCurA = pcA;
    while (pcCurA[iSubLen])
    {  //    A   ,      
       //    ,     B.
       int i;
       for (i = 0; i <= iSubLen; i++)
          if (pcB[i] != pcCurA[i]) //   .
          {   //        ,
              //      .  
              //  A         B.
              pcCurA++;
              goto ContinueInnerWhileLoopLabel;
          }
       result.iMatchesQty++; //  ,   .
       break;  //      A,   
               //   B     A.
ContinueInnerWhileLoopLabel:;
    }
    result.iVariantsQty++;
    pcB++;
 }
 return result;
}

/*
     similarity   ""  .
    ,     
  ,     iMaxLen,   
  .      
 "".
        .   BC 4.5,
 Watcom 11.0, MSVC 5.0.        DLL, 
    EXE ,       
 double.
*/
#ifdef __BORLANDC__
double __stdcall __export similarity (int iMaxLen, TCHAR* pcA, TCHAR* pcB)
#else  // for Watcom or Microsoft
__declspec (dllexport) double __stdcall similarity (int iMaxLen, TCHAR* pcA, TCHAR* pcB)
#endif // __BORLANDC__
{
 CompResult total;
 int iCurSubLen = 0; //   .

 if (iMaxLen <= 0 || pcA == NULL || pcB == NULL)
    return 0;   //   .

 total.iVariantsQty = total.iMatchesQty = 0;

 while (iCurSubLen < iMaxLen && pcA[iCurSubLen] && pcB[iCurSubLen])
 {
    CompResult res;

    //   A   B.
    res = processStrings (pcA, pcB, iCurSubLen);
    total.iVariantsQty += res.iVariantsQty;
    total.iMatchesQty  += res.iMatchesQty;
    //   B   A.
    res = processStrings (pcB, pcA, iCurSubLen);
    total.iVariantsQty += res.iVariantsQty;
    total.iMatchesQty  += res.iMatchesQty;

    iCurSubLen++;
 }
 if (total.iVariantsQty == 0)
    return 0; //  .

 return (double)total.iMatchesQty / (double)total.iVariantsQty;
}

